﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

struct ShaderParams {
	kernel : f32,
	angle : f32,
	spacing : f32
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	let r: f32 = radians(- shaderParams.angle + 90.);
	let angleR: vec2<f32> = shaderParams.spacing * vec2<f32>(sin(r), cos(r));
	let pixelSize: vec2<f32> = c3_getPixelSize(textureFront).xy;
	var col: vec4<f32> = vec4<f32>(0.);

	for (var i: f32 = 1.; i <= shaderParams.kernel; i = i + 1.) {
		col = col + textureSample(textureFront, samplerFront, input.fragUV - angleR * (i - shaderParams.kernel * 0.5) * pixelSize);
	}

	var output : FragmentOutput;
	output.color = col / shaderParams.kernel;
	return output;
}